//requirejs('controls/toastMessage');

var lastCookiePageTm = 0;
var googleURLTest = /\.google\./i;
var criticalErrorDisplayed = false;

String.prototype._decodeHTML = function () {
    var map = { "gt": ">", "lt": "<", "quot": "\"", "amp": "&", "nbsp":" ", "Scaron": "Š", "scaron": "š", "circ": "ˆ", "tilde":"˜",
        "ensp": " ", "emsp": " ", "thinsp": " ", "ndash": "–", "mdash": "—", "lsquo": "‘", "rsquo": "’", "sbquo": "‚", "ldquo": "“",
        "rdquo": "”", "bdquo": "„", "dagger": "†", "Dagger": "‡", "permil": "‰", "lsaquo": "‹", "rsaquo": "›", "euro": "€",
        "frasl": "/", "deg": "°", "plusmn": "±", "sup2": "²", "sup3": "³", "acute": "´", "micro": "µ", "para": "¶", "cedil": "¸",
        "sup1": "¹", "ordm": "º", "frac14": "¼", "frac12": "½", "frac34": "¾", "iquest": "¿", "Agrave": "À", "Aacute": "Á", "Acirc": "Â",
        "Atilde": "Ã", "Auml": "Ä", "Aring": "Å", "AElig": "Æ", "Ccedil": "Ç", "Egrave": "È", "Eacute": "É", "Ecirc": "Ê", "Euml": "Ë",
        "Igrave": "Ì", "Iacute": "Í", "Icirc": "Î", "Iuml": "Ï", "ETH": "Ð", "Ntilde": "Ñ", "Ograve": "Ò", "Oacute": "Ó", "Ocirc": "Ô",
        "Otilde": "Õ", "Ouml": "Ö", "times": "×", "Oslash": "Ø", "Ugrave": "Ù", "Uacute": "Ú", "Ucirc": "Û", "Uuml": "Ü", "Yacute": "Ý",
        "THORN": "Þ", "szlig": "ß", "agrave": "à", "aacute": "á", "acirc": "â", "atilde": "ã", "auml": "ä", "aring": "å", "aelig": "æ",
        "ccedil": "ç", "egrave": "è", "eacute": "é", "ecirc": "ê", "euml": "ë", "igrave": "ì", "iacute": "í", "icirc": "î", "iuml": "ï",
        "eth": "ð", "ntilde": "ñ", "ograve": "ò", "oacute": "ó", "ocirc": "ô", "otilde": "õ", "ouml": "ö", "divide": "÷", "oslash": "ø",
        "ugrave": "ù", "uacute": "ú", "ucirc": "û", "uuml": "ü", "yacute": "ý", "thorn": "þ", "yuml": "ÿ", "Yuml": "Ÿ", "copy": "©", "trade": "™"
    };
    return this.replace(/&(#(?:x[0-9a-f]+|\d+)|[a-z]+);?/gi, function ($0, $1) {
        if ($1[0] === "#") {
            return String.fromCharCode($1[1].toLowerCase() === "x" ? parseInt($1.substr(2), 16) : parseInt($1.substr(1), 10));
        } else {
            return map.hasOwnProperty($1) ? map[$1] : $0;
        }
    });
};

function decodeHTML(x) {
    return x._decodeHTML();
}

function isObjectLiteral(x) {
    return ((!!x) && (x.constructor === Object));
}

function isArray(x) {
    return Array.isArray(x);
}



function ODS(str) {
    NotifyDebug(str);
}


function tryEval(content) {

    try {
     //ODS('Error during evaluation, ' + content);
        let res = (new Function('return ' + content ))();
        return res;
    }
    catch (err) {
        ODS('Error during evaluation, ' + err);
        return undefined;
    }
}


function SearchTools(){
  //this.parseGoogleImgSearchResponse=null;
}
var searchTools = new SearchTools();



searchTools.isCookiePage = function (html) {
    // currently skipped, seems not needed
/*    var googleTest = /action="https:\/\/consent\.google\.com\/save"/i;
    if (googleTest.test(html)) {
        return true;
    };
*/
    // add Bing page detection - currently unclear

    return false;
}

searchTools.parseGoogleImgSearchResponse = function (html) {
   NotifyDebug('parseGoogleImgSearchResponse.start');
    var result = [];
    try {
        //app.filesystem.saveTextToFileAsync(app.filesystem.getDataFolder() + '\\googleResult.html', html);
        // find function filling structure with results
        var re = /\(function\(\)\{var m=(.*?)\]\]\][ ]*\}/ig;
        var prepArr = html.match(re);
        var larray = undefined;
        var prepText = '';
        if (prepArr && (prepArr.length > 0)) {
            prepArr.forEach((itm) => {
                if (itm && (itm.length > prepText.length))
                    prepText = itm;
            });
            if (prepText.length > 18) {
                // cut off function wrapping
                prepText = prepText.slice(18);
            } else {
                prepText = '';
            }
        }

        if (prepText && (prepText.length > 1) && (prepText[0] === '{') && (prepText[prepText.length - 1] === '}')) {
            //app.filesystem.saveTextToFileAsync(app.filesystem.getDataFolder() + '\\googleResultPrep.html', prepText);
            larray = tryEval(prepText);
        }
        if (!larray) {
            if (ODS)
                ODS('rSuccessGoogle: larray is NULL');
        } else {
            //app.filesystem.saveTextToFileAsync(app.filesystem.getDataFolder() + '\\googleResultPrep.json', JSON.stringify(larray));
            if(isObjectLiteral(larray)) {
                let val, key, val1, th, im;
                let i = 0;
                for (key in larray) {
                    val = larray[key];
                    if(isArray(val) && (val.length>7)) {
                        val1 = val[1];
                        if(isArray(val1) && (val1.length>9)) {
                            th = val1[2];
                            im = val1[3];
                            if(isArray(th) && isArray(im) && (th.length>2) && (im.length>2)) {
                                if (ODS)
                                    ODS('Adding result ' + (i + 1) + ': '+JSON.stringify(im));
                                i++;
                                var res = {};
                                res.imglink = decodeURIComponent(im[0]); // some links are double encoded, see mantis #13047 for details - maybe already not needed? Trying used once only.
                                res.width = im[2];
                                res.height = im[1];
                                res.thumblink = decodeURIComponent(th[0]);
                                res.thumbwidth = th[2];
                                res.thumbheight = th[1];
                                result.push(res);
                            };
                        };
                    };
                }
            }
        }
    } catch (ex) {
        if (ODS)
            ODS(ex.message);
    }
    return result;
}

searchTools.parseBingImgSearchResponse = function (html) {
    var result = [];
    try {
        //app.filesystem.saveTextToFileAsync(app.filesystem.getDataFolder() + '\\bingResult.html', html);
        // all items after <div class="imgpt">
        var mlist = html.split('<div class="imgpt">');

        if (mlist && (mlist.length > 1)) {
            ODS('rSuccessBing: split to ' + mlist.length + ' items');
            var txt, params, dtxt;
            var rg_m = /m="\{(.*?)\}"/i;
            var rg_w = /expw=([\d]*)/i;
            var rg_h = /exph=([\d]*)/i;

            for (var i = 1; i < mlist.length; i++) {
                txt = mlist[i];
                // m="{..}"
                params = rg_m.exec(txt);
                if (params && (params[1])) {
                    try {
                        var res = {};
                        dtxt = '{' + decodeHTML(params[1]) + '}';
                        dtxt = JSON.parse(dtxt);
                        res.imglink = dtxt.murl;
                        res.thumblink = dtxt.turl + '&w=189&h=189';
                        res.thumbwidth = 189;
                        res.thumbheight = 189;
                        res.width = rg_w.exec(txt)[1];
                        res.height = rg_h.exec(txt)[1];
                        result.push(res);
                    } catch (ex) {
                        if (ODS)
                            ODS('rSuccessBing error: ' + ex.message);
                    }
                } else {
                    if (ODS)
                        ODS('rSuccessBing: not found in ' + txt);
                }
            }

            if (ODS)
                ODS('rSuccessBing: filled ' + result.length + ' results');
        }
    } catch (ex) {
        if (ODS)
            ODS(ex.message);
    }
    return result;
}
