


String.prototype._decodeHTML = function () {
    var map = { "gt": ">", "lt": "<", "quot": "\"", "amp": "&", "nbsp":" ", "Scaron": "Š", "scaron": "š", "circ": "ˆ", "tilde":"˜",
        "ensp": " ", "emsp": " ", "thinsp": " ", "ndash": "–", "mdash": "—", "lsquo": "‘", "rsquo": "’", "sbquo": "‚", "ldquo": "“",
        "rdquo": "”", "bdquo": "„", "dagger": "†", "Dagger": "‡", "permil": "‰", "lsaquo": "‹", "rsaquo": "›", "euro": "€",
        "frasl": "/", "deg": "°", "plusmn": "±", "sup2": "²", "sup3": "³", "acute": "´", "micro": "µ", "para": "¶", "cedil": "¸",
        "sup1": "¹", "ordm": "º", "frac14": "¼", "frac12": "½", "frac34": "¾", "iquest": "¿", "Agrave": "À", "Aacute": "Á", "Acirc": "Â",
        "Atilde": "Ã", "Auml": "Ä", "Aring": "Å", "AElig": "Æ", "Ccedil": "Ç", "Egrave": "È", "Eacute": "É", "Ecirc": "Ê", "Euml": "Ë",
        "Igrave": "Ì", "Iacute": "Í", "Icirc": "Î", "Iuml": "Ï", "ETH": "Ð", "Ntilde": "Ñ", "Ograve": "Ò", "Oacute": "Ó", "Ocirc": "Ô",
        "Otilde": "Õ", "Ouml": "Ö", "times": "×", "Oslash": "Ø", "Ugrave": "Ù", "Uacute": "Ú", "Ucirc": "Û", "Uuml": "Ü", "Yacute": "Ý",
        "THORN": "Þ", "szlig": "ß", "agrave": "à", "aacute": "á", "acirc": "â", "atilde": "ã", "auml": "ä", "aring": "å", "aelig": "æ",
        "ccedil": "ç", "egrave": "è", "eacute": "é", "ecirc": "ê", "euml": "ë", "igrave": "ì", "iacute": "í", "icirc": "î", "iuml": "ï",
        "eth": "ð", "ntilde": "ñ", "ograve": "ò", "oacute": "ó", "ocirc": "ô", "otilde": "õ", "ouml": "ö", "divide": "÷", "oslash": "ø",
        "ugrave": "ù", "uacute": "ú", "ucirc": "û", "uuml": "ü", "yacute": "ý", "thorn": "þ", "yuml": "ÿ", "Yuml": "Ÿ", "copy": "©", "trade": "™"
    };
    return this.replace(/&(#(?:x[0-9a-f]+|\d+)|[a-z]+);?/gi, function ($0, $1) {
        if ($1[0] === "#") {
            return String.fromCharCode($1[1].toLowerCase() === "x" ? parseInt($1.substr(2), 16) : parseInt($1.substr(1), 10));
        } else {
            return map.hasOwnProperty($1) ? map[$1] : $0;
        }
    });
};

//searchTools.readWebPageAsync = function (url) {
//    return new Promise(function (resolve) {
//        let mainWnd = app.dialogs.getMainWindow();
//        let w = mainWnd.createOwnWindow(url, {
//            left: 0,
//            top: 0,
//            width: 1920,
//            height: 1200,
//            show: false
//        });
//        w.doLoaded = function () {
//            app.unlisten(this, 'load', this.doLoaded);
//            this.isloaded = true;
//            resolve(w._window.document.body.innerHTML);
//            this.closeWindow();
//        }.bind(w);
//        app.listen(w, 'load', w.doLoaded);
//    });
function SearchTools(){
  this.parseGoogleImgSearchResponse=null;
}

var searchTools = new SearchTools();


searchTools.parseGoogleImgSearchResponse = function (html) {
    var result = [];
    try {
        //        app.filesystem.saveTextToFileAsync(app.filesystem.getDataFolder() + '\\googleResult.html', html);
        var re = /"b-GRID_STATE0"[^\[]+\["GRID_STATE0"[^\[]+(\[(.|\n)*)/i; // look for [ after "b-GRID_STATE0" ...["GRID_STATE0" and take the rest till the end
        var prepText = html.match(re);
        var larray = undefined;
        if (prepText){
          NotifyDebug('rSuccessGoogle: prepText.length: '+prepText.length);
        }else{
          NotifyDebug('rSuccessGoogle: no prepText');
        }

        if (prepText && (prepText.length > 1)) {
            prepText = prepText[1];
            // we have deeply nested array and ending from upper arrays, cut only first array with all nested parts
            var level = 1;
            var l = prepText.length;
            var ch;
            var idx = 1;
            var lastBegin = -1;
            larray = [];
            var insideQuotes = false;
            while ((level > 0) && (idx < l) && (larray.length < 50)) { // take only the first 50 results
                ch = prepText.charAt(idx);
                if (!insideQuotes) {
                    if (ch === '[') {
                        level++;
                        if (level === 2)
                            lastBegin = idx;
                    } else if (ch === ']') {
                        level--;
                        if (level === 1) {
                            var addStr = prepText.substring(lastBegin, idx + 1);
                            if (addStr.charAt(1) === '1') { // it seems other numbers like 2 is not search result we want
                                //                                ODS('Adding item ' + (larray.length + 1) + ': ' + addStr);
                                larray.push(addStr);
                                //                                ODS('Added item ' + larray.length);
                            }
                        }
                    }
                }
                if ((ch === '"') && (prepText.charAt(idx - 1) !== '\\')) {
                    insideQuotes = !insideQuotes;
                }
                idx++;
            }
        }
        if (!larray) {
            if(NotifyDebug)
                NotifyDebug('rSuccessGoogle: larray is NULL');
        }
        else {
            if(NotifyDebug)
                NotifyDebug('rSuccessGoogle: going to fill ' + larray.length + ' results');
            for (var i = 0; i < larray.length; i++) {
                var itemStr = larray[i];
                //ODS('Parsing result ' + (i+1) + ', ' + itemStr);
                var item = JSON.parse(itemStr);
                if (item) {
                    item = item[1];
                    if (item && item[3]) {
                        var res = {};
                        res.imglink = decodeURIComponent(decodeURIComponent(item[3][0])); // some links are double encoded, see mantis #13047 for details
                        res.width = item[3][2];
                        res.height = item[3][1];
                        res.thumblink = decodeURIComponent(item[2][0]);
                        res.thumbwidth = item[2][2];
                        res.thumbheight = item[2][1];
                        result.push(res);
                    }
                }
            }
        }
    } catch (ex) {
        if(NotifyDebug)
            NotifyDebug(ex.message);
    }
    return result;
}

searchTools.parseBingImgSearchResponse = function (html) {
    var result = [];
    try {
        // app.filesystem.saveTextToFileAsync(app.filesystem.getDataFolder() + '\\bingResult.html', html);
        // all items after <div class="imgpt">
        var mlist = html.split('<div class="imgpt">');

        if (mlist && (mlist.length > 1)) {
            NotifyDebug('--- split to ' + mlist.length + ' items');
            var txt, params, dtxt;
            var rg_m = /m="\{(.*?)\}"/i;
            var rg_w = /expw=([\d]*)/i;
            var rg_h = /exph=([\d]*)/i;

            for (var i = 1; i < mlist.length; i++) {
                txt = mlist[i];
                // m="{..}"
                params = rg_m.exec(txt);
                if (params && (params[1])) {
                    try {
                        var res = {};
                        dtxt = '{' + params[1]._decodeHTML() + '}';
                        dtxt = JSON.parse(dtxt);
                        res.imglink = dtxt.murl;
                        res.thumblink = dtxt.turl + '&w=189&h=189';
                        res.thumbwidth = 189;
                        res.thumbheight = 189;
                        res.width = rg_w.exec(txt)[1];
                        res.height = rg_h.exec(txt)[1];
                        result.push(res);
                    } catch (ex) {
                        if (NotifyDebug)
                            NotifyDebug('rSuccessBing error: ' + ex.message);
                    }
                } else {
                    if (NotifyDebug)
                        NotifyDebug('rSuccessBing: not found in ' + txt);
                }
            }

            if (NotifyDebug)
                NotifyDebug('rSuccessBing: filled ' + result.length + ' results');
        }
    } catch (ex) {
        if (NotifyDebug)
            NotifyDebug(ex.message);
    }
    return result;
}
