var rLyricWikia = new LyricsSource();
rLyricWikia.onSuccess = function (html) {
    NotifyDebug('rSuccessLyricWikia');
    var l = '';
    var p = '';
    try {
        l = html.split('<div class=\'lyricbox\'>')[1].split('<div class=\'lyricsbreak\'>')[0].trim();
        l = l.replace(/<div(.*?)<\/div>/gi, ''); // #11541
        l = cleanupLyrics(l);
        if (l.length < 3) {
            l = html.split('<div class=\'lyricbox\'>')[2].split('<div class=\'lyricsbreak\'>')[0].trim();
            l = l.replace(/<div(.*?)<\/div>/gi, ''); // #11541
            l = cleanupLyrics(l);
        }
        if (l) {
            p = 'Lyric.Wikia.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rLyricWikia.onFailure = requestNext;
rLyricWikia.host = 'http://lyrics.wikia.com/wiki/%artist%:%title%';
rLyricWikia.sendString = '';
rLyricWikia.name = 'Lyrics Wiki';
rLyricWikia.formatURL = function (host) {
    return host.replace(/\s+/g, '_').replace(/’+/g, '\'');
};
window.lyricsSources.push(rLyricWikia);


var rSeekALyric = new LyricsSource();
rSeekALyric.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<div id="contentt" style="FONT-SIZE: 13px;">')[1].split('</div>')[0].split('<span id=')[0];
        l = cleanupLyrics(l);
        if (l) {
            p = "seekalyric.com";
        }
    } catch (ex) {}
    whatNext(l, p);
};
rSeekALyric.onFailure = requestNext;
rSeekALyric.host = 'http://www.seekalyric.com/song/%artist%/%title%';
rSeekALyric.sendString = '';
rSeekALyric.name = 'Seek A Lyric';
rSeekALyric.formatURL = function (host) {
    return host.replace(/\s+/g, '_').replace(/[\'|’]+/g, '_');
};
window.lyricsSources.push(rSeekALyric);


var rELyrics = new LyricsSource();
rELyrics.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<div id=\'inlyr\'>')[1].split('</div><br>')[0].trim();
        // contains some divs with ads by Google, change them to new lines only
        l = l.replace(/(\r|\n)/g, ''); // remove End of Line, so next replace works correcty
        l = l.replace(/<div(.*?)>(.*?)<\/div>/gi, '<br><br>'); // Google ads div
        l = cleanupLyrics(l);
        if (l) {
            p = 'ELyrics.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rELyrics.onFailure = requestNext;
rELyrics.host = 'http://www.elyrics.net/read/%artistfirstchar%/%artist%-lyrics/%title%-lyrics.html';
rELyrics.sendString = '';
rELyrics.name = 'ELyrics';
rELyrics.formatURL = function (host) {
    return host.replace(/\s+/g, '-').replace(/\'+/g, '_').toLowerCase();
};
window.lyricsSources.push(rELyrics);


var rMetroLyrics = new LyricsSource();
rMetroLyrics.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<div id="lyrics-body-text">')[1].split('</div>')[0].replace(/<p class='verse'>/gi, "<br>").replace(/<\/p>/gi, "").trim();
        l = cleanupLyrics(l);
        if (l) {
            p = 'metrolyrics.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rMetroLyrics.onFailure = requestNext;
rMetroLyrics.host = 'http://www.metrolyrics.com/%title%-lyrics-%artist%.html';
rMetroLyrics.sendString = '';
rMetroLyrics.name = 'Metro Lyrics';
rMetroLyrics.formatURL = function (host) {
    return host.replace(/\s+/g, '-').replace(/\'+/g, '').toLowerCase();
};
window.lyricsSources.push(rMetroLyrics);


var rLyricsMode = new LyricsSource();
rLyricsMode.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        var rg = /<div id="lyrics_text"[^>]*>[\s]*(.*?)[\s]*<div/igms;
        var m = rg.exec(html);
        if (m.length > 1) {
            l = cleanupLyrics(m[1]);
            if (l) {
                p = 'lyricsmode.com';
            }
        }
    } catch (ex) {}
    whatNext(l, p);
};
rLyricsMode.onFailure = requestNext;
rLyricsMode.host = 'http://www.lyricsmode.com/lyrics/%artistfirstchar%/%artist%/%title%.html';
rLyricsMode.sendString = '';
rLyricsMode.name = 'Lyrics Mode';
rLyricsMode.formatURL = function (host) {
    return host.replace(/\s+/g, '_').replace(/\'+/g, '').toLowerCase().replace(/\?/g, '');
};
window.lyricsSources.push(rLyricsMode);


var rSongColeta = new LyricsSource();
rSongColeta.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<div id="lyrics"')[1].split('">')[1].split('</div>')[0].trim();
        l = cleanupLyrics(l);
        if (l) {
            p = 'songcoleta.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rSongColeta.onFailure = requestNext;
rSongColeta.host = 'http://www.songcoleta.com/lyrics/%title%_(%artist%)';
rSongColeta.sendString = '';
rSongColeta.name = 'SongColeta';
rSongColeta.formatURL = function (host) {
    return host.replace(/\s+/g, '_');
};
//window.lyricsSources.push(rSongColeta); do not response, can verify later


var rLoloLyrics = new LyricsSource();
rLoloLyrics.onSuccess = function (html) {
    NotifyDebug('rSuccessLoloLyrics');
    var l = '';
    var p = '';
    try {
        var status = html.split('<status>')[1].split('</status>')[0];
        if (status === 'OK') {
            l = html.split('<response>')[1].split('</response>')[0];
            l = l.replace(/\&#13;/gi, '<br>'); // Converts all "New Line" to br tag
            if (l) {
                p = 'LoloLyrics.com';
            }
        }
    } catch (ex) {}
    whatNext(l, p);
};
rLoloLyrics.onFailure = requestNext;
rLoloLyrics.host = 'http://api.lololyrics.com/0.5/getLyric?artist=%artist%&track=%title%';
rLoloLyrics.sendString = '';
rLoloLyrics.name = 'LoloLyrics';
window.lyricsSources.push(rLoloLyrics);


/* // disabled because of #12711 
var rAZLyrics = new LyricsSource(); 
rAZLyrics.onSuccess = function (html) {
    NotifyDebug('rSuccessAZLyrics');
    var l = '';
    var p = '';
    try {
        l = html.split('<!-- start of lyrics -->')[1].split('<!-- end of lyrics -->')[0]._trim();
        l = cleanupLyrics(l);
        if (l) {
            p = 'AZLyrics.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rAZLyrics.onFailure = requestNext;
rAZLyrics.host = 'http://www.azlyrics.com/lyrics/%artist%/%title%.html';
rAZLyrics.sendString = '';
rAZLyrics.name = 'AZ Lyrics';
rAZLyrics.formatURL = function(host) { return host.replace(/(\s|\&)+/g, '').replace(/\'+/g, '').toLowerCase();};
rAZLyrics.formatArtist = function(a) { a = removeDiacritics(a);  
                                       a = a.replace(/\W/g, ''); // leave only alphanumeric 
                                       return a;
                                      };
rAZLyrics.formatTitle = function(t) { return t.replace(/\W/g, ''); }; // leave only alphanumeric 
window.lyricsSources.push(rAZLyrics); // no longer searched by us (details in #12711)
*/


/* // does not work anymore
var rLyricsSongs = new LyricsSource();
rLyricsSongs.onSuccess = function (html) {
    var l = '';
    var p = '';
    try {
        var tmp = html.split('<h2>')[1].split('<p>');
        l = l.concat(tmp[1].split('</p>')[0]._trim());
        for (var i = 2; i < tmp.length - 1; i++) {
            l = l.concat('<br><br>', tmp[i].split('</p>')[0]._trim());
        }
        l = cleanupLyrics(l);
        if (l) {
            p = 'Letras.mus.br';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rLyricsSongs.onFailure = requestNext;
rLyricsSongs.host = 'http://letras.terra.com.br/winamp.php?artista=%artist%&musica=%title%';
rLyricsSongs.sendString = 'artista=%artist%&musica=%title%';
rLyricsSongs.name = 'Lyrics Songs';
window.lyricsSources.push(rLyricsSongs);
*/


/* // does not work anymore (lyrics given by ID)
var rMp3Lyrics = new LyricsSource();
rMp3Lyrics.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<div id="lyrics_text"')[1].split('">')[1].split('<span id=')[0];
        l += html.split('<span id="findmorespan">')[1].split('</span>')[1].split('</div>')[0].trim();
        l = cleanupLyrics(l);
        if (l) {
            p = 'mp3lyrics.org';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rMp3Lyrics.onFailure = requestNext;
rMp3Lyrics.host = 'http://www.mp3lyrics.org/%artist%/%title%';
rMp3Lyrics.sendString = '';
rMp3Lyrics.name = 'Mp3Lyrics';
rMp3Lyrics.formatURL = function(host) { return host.replace(/\s+/g, '-').replace(/\'+/g, '').toLowerCase();};
window.lyricsSources.push(rMp3Lyrics); // does not work anymore (lyrics given by ID)
*/


/* // does not work (404)
var rLyricstime = new LyricsSource();
rLyricstime.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<div id="songlyrics"')[1].split('<p>')[1].split('</p>')[0].trim();
        l = cleanupLyrics(l);
        if (l) {
            p = 'lyricstime.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rLyricstime.onFailure = requestNext;
rLyricstime.host = 'http://www.lyricstime.com/%artist%-%title%-lyrics.html';
rLyricstime.sendString = '';
rLyricstime.name = 'lyricstime';
rLyricstime.formatURL = function(host) { return  host.replace(/\s+/g, '-').replace(/\'+/g, '-').toLowerCase();};
window.lyricsSources.push(rLyricstime); // does not work (404)
*/


/* // does not work anymore (redirected to eMusic root)
var rHiplyrics = new LyricsSource();
rHiplyrics.onSuccess = function (html, xml) {
    var l = '';
    var p = '';
    try {
        l = html.split('<p id="lyricsbody" class="translate">')[1].split('</p>')[0].trim();
        l = cleanupLyrics(l);
        if (l) {
            p = 'hipyrics.com';
        }
    } catch (ex) {}
    whatNext(l, p);
};
rHiplyrics.onFailure = requestNext;
rHiplyrics.host = 'http://www.hiplyrics.com/lyrics/%title%-by-%artist%-lyrics.html';
rHiplyrics.sendString = '';
rHiplyrics.name = 'hiplyrics';
rHiplyrics.formatURL = function(host) { return host.replace(/\s+/g, '-').replace(/\'+/g, '').toLowerCase();};
window.lyricsSources.push(rHiplyrics); // does not work anymore (redirected to eMusic root)
*/
